<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>eRPC API Reference: RPMsgZCMessageBufferFactory Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<link href="customdoxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eRPC API Reference
   &#160;<span id="projectnumber">Rev. 1.4.0</span>
   </div>
   <div id="projectbrief">NXP Semiconductors</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>API&#160;Reference</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_r_p_msg_z_c_message_buffer_factory.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="class_r_p_msg_z_c_message_buffer_factory-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">RPMsgZCMessageBufferFactory Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>RPMsg zero copy message buffer factory.  
 <a href="class_r_p_msg_z_c_message_buffer_factory.html#details">More...</a></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for RPMsgZCMessageBufferFactory:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
<div class="center"><iframe scrolling="no" frameborder="0" src="class_r_p_msg_z_c_message_buffer_factory__inherit__graph.svg" width="222" height="112"><p><b>This browser is not able to show SVG: try Firefox, Chrome, Safari, or Opera instead.</b></p></iframe>
</div>
<center><span class="legend">[<a target="top" href="graph_legend.html">legend</a>]</span></center></div>
<div id="dynsection-1" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-1-trigger" src="closed.png" alt="+"/> Collaboration diagram for RPMsgZCMessageBufferFactory:</div>
<div id="dynsection-1-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-1-content" class="dyncontent" style="display:none;">
<div class="center"><iframe scrolling="no" frameborder="0" src="class_r_p_msg_z_c_message_buffer_factory__coll__graph.svg" width="222" height="112"><p><b>This browser is not able to show SVG: try Firefox, Chrome, Safari, or Opera instead.</b></p></iframe>
</div>
<center><span class="legend">[<a target="top" href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aae346bf852c606bab49c203710f7f1b7"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_r_p_msg_z_c_message_buffer_factory.html#aae346bf852c606bab49c203710f7f1b7">RPMsgZCMessageBufferFactory</a> (struct rpmsg_lite_instance *rpmsg)</td></tr>
<tr class="memdesc:aae346bf852c606bab49c203710f7f1b7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#aae346bf852c606bab49c203710f7f1b7">More...</a><br /></td></tr>
<tr class="separator:aae346bf852c606bab49c203710f7f1b7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2a4f0c9414933a12014d13d4e1dcb2f7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2a4f0c9414933a12014d13d4e1dcb2f7"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_r_p_msg_z_c_message_buffer_factory.html#a2a4f0c9414933a12014d13d4e1dcb2f7">~RPMsgZCMessageBufferFactory</a> ()</td></tr>
<tr class="memdesc:a2a4f0c9414933a12014d13d4e1dcb2f7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor. <br /></td></tr>
<tr class="separator:a2a4f0c9414933a12014d13d4e1dcb2f7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af03d26b64bd1eaaac6370e98ae9b1e56"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classerpc_1_1_message_buffer.html">MessageBuffer</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_r_p_msg_z_c_message_buffer_factory.html#af03d26b64bd1eaaac6370e98ae9b1e56">create</a> ()</td></tr>
<tr class="memdesc:af03d26b64bd1eaaac6370e98ae9b1e56"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function creates new message buffer.  <a href="#af03d26b64bd1eaaac6370e98ae9b1e56">More...</a><br /></td></tr>
<tr class="separator:af03d26b64bd1eaaac6370e98ae9b1e56"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa01dbe0016f3bda820c0c841be176ceb"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_r_p_msg_z_c_message_buffer_factory.html#aa01dbe0016f3bda820c0c841be176ceb">dispose</a> (<a class="el" href="classerpc_1_1_message_buffer.html">MessageBuffer</a> *buf)</td></tr>
<tr class="memdesc:aa01dbe0016f3bda820c0c841be176ceb"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function disposes message buffer.  <a href="#aa01dbe0016f3bda820c0c841be176ceb">More...</a><br /></td></tr>
<tr class="separator:aa01dbe0016f3bda820c0c841be176ceb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6ff1c2504ac5d562d5cc114037122d99"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__infra.html#ga5f8872e58f09a16d192bf664f9898651">erpc_status_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_r_p_msg_z_c_message_buffer_factory.html#a6ff1c2504ac5d562d5cc114037122d99">prepareServerBufferForSend</a> (<a class="el" href="classerpc_1_1_message_buffer.html">MessageBuffer</a> *message)</td></tr>
<tr class="memdesc:a6ff1c2504ac5d562d5cc114037122d99"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function is preparing output buffer on server side.  <a href="#a6ff1c2504ac5d562d5cc114037122d99">More...</a><br /></td></tr>
<tr class="separator:a6ff1c2504ac5d562d5cc114037122d99"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a396a52d2e2b3b122a71b3b92facc376e"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_r_p_msg_z_c_message_buffer_factory.html#a396a52d2e2b3b122a71b3b92facc376e">createServerBuffer</a> ()</td></tr>
<tr class="memdesc:a396a52d2e2b3b122a71b3b92facc376e"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function inform server if it has to create buffer for received message.  <a href="#a396a52d2e2b3b122a71b3b92facc376e">More...</a><br /></td></tr>
<tr class="separator:a396a52d2e2b3b122a71b3b92facc376e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classerpc_1_1_message_buffer_factory"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classerpc_1_1_message_buffer_factory')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classerpc_1_1_message_buffer_factory.html">erpc::MessageBufferFactory</a></td></tr>
<tr class="memitem:a9897093c65b390b0c7f1595384ad9029 inherit pub_methods_classerpc_1_1_message_buffer_factory"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpc_1_1_message_buffer_factory.html#a9897093c65b390b0c7f1595384ad9029">MessageBufferFactory</a> ()</td></tr>
<tr class="memdesc:a9897093c65b390b0c7f1595384ad9029 inherit pub_methods_classerpc_1_1_message_buffer_factory"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a9897093c65b390b0c7f1595384ad9029">More...</a><br /></td></tr>
<tr class="separator:a9897093c65b390b0c7f1595384ad9029 inherit pub_methods_classerpc_1_1_message_buffer_factory"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac2b0d9092be2a6e757dcc4bdc8baefd5 inherit pub_methods_classerpc_1_1_message_buffer_factory"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac2b0d9092be2a6e757dcc4bdc8baefd5"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classerpc_1_1_message_buffer_factory.html#ac2b0d9092be2a6e757dcc4bdc8baefd5">~MessageBufferFactory</a> ()</td></tr>
<tr class="memdesc:ac2b0d9092be2a6e757dcc4bdc8baefd5 inherit pub_methods_classerpc_1_1_message_buffer_factory"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classerpc_1_1_client_manager.html" title="Base client implementation. ">ClientManager</a> destructor. <br /></td></tr>
<tr class="separator:ac2b0d9092be2a6e757dcc4bdc8baefd5 inherit pub_methods_classerpc_1_1_message_buffer_factory"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a6f9aedcfcad6830574a53b7f9f4d56d6"><td class="memItemLeft" align="right" valign="top">struct rpmsg_lite_instance *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_r_p_msg_z_c_message_buffer_factory.html#a6f9aedcfcad6830574a53b7f9f4d56d6">m_rpmsg</a></td></tr>
<tr class="separator:a6f9aedcfcad6830574a53b7f9f4d56d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>RPMsg zero copy message buffer factory. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="aae346bf852c606bab49c203710f7f1b7"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">RPMsgZCMessageBufferFactory::RPMsgZCMessageBufferFactory </td>
          <td>(</td>
          <td class="paramtype">struct rpmsg_lite_instance *&#160;</td>
          <td class="paramname"><em>rpmsg</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">rpmsg</td><td>Pointer to instance of RPMSG lite. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="af03d26b64bd1eaaac6370e98ae9b1e56"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classerpc_1_1_message_buffer.html">MessageBuffer</a> RPMsgZCMessageBufferFactory::create </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This function creates new message buffer. </p>
<dl class="section return"><dt>Returns</dt><dd>MessageBuffer New created MessageBuffer. </dd></dl>

<p>Implements <a class="el" href="classerpc_1_1_message_buffer_factory.html#a988ac3778b4164dc497429128078447b">erpc::MessageBufferFactory</a>.</p>

</div>
</div>
<a class="anchor" id="aa01dbe0016f3bda820c0c841be176ceb"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void RPMsgZCMessageBufferFactory::dispose </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classerpc_1_1_message_buffer.html">MessageBuffer</a> *&#160;</td>
          <td class="paramname"><em>buf</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This function disposes message buffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">buf</td><td>MessageBuffer to dispose. </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classerpc_1_1_message_buffer_factory.html#a089b5bf3041323a3387c52c86fd61971">erpc::MessageBufferFactory</a>.</p>

</div>
</div>
<a class="anchor" id="a6ff1c2504ac5d562d5cc114037122d99"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="group__infra.html#ga5f8872e58f09a16d192bf664f9898651">erpc_status_t</a> RPMsgZCMessageBufferFactory::prepareServerBufferForSend </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classerpc_1_1_message_buffer.html">MessageBuffer</a> *&#160;</td>
          <td class="paramname"><em>message</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This function is preparing output buffer on server side. </p>
<p>This function do decision if this function want reuse buffer, or use new buffer. In case of using new buffer function has to free given buffer.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">message</td><td>MessageBuffer which can be reused. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented from <a class="el" href="classerpc_1_1_message_buffer_factory.html#aab77e9b0501e87a332f4cb3e2835bd54">erpc::MessageBufferFactory</a>.</p>

</div>
</div>
<a class="anchor" id="a396a52d2e2b3b122a71b3b92facc376e"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool RPMsgZCMessageBufferFactory::createServerBuffer </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This function inform server if it has to create buffer for received message. </p>
<dl class="section return"><dt>Returns</dt><dd>Has to return TRUE when server need create buffer for receiving message. </dd></dl>

<p>Reimplemented from <a class="el" href="classerpc_1_1_message_buffer_factory.html#a27ba896a8eb9a1aee6b02894acd724cf">erpc::MessageBufferFactory</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="a6f9aedcfcad6830574a53b7f9f4d56d6"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">struct rpmsg_lite_instance* RPMsgZCMessageBufferFactory::m_rpmsg</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Pointer to instance of RPMSG lite. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>erpc_setup_mbf_rpmsg_zc.cpp</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- HTML footer for doxygen 1.8.5-->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul class="foot">
    <li class="footer">&copy; 2016 NXP Semiconductors. All rights reserved.
    </li>
  </ul>
</div>
</body>
</html>
